package;

import haxegon.*;

class Bullet extends Entity
{
	public function new(_x:Float, _y:Float, _dirx:Int, _diry:Int)
	{
		super();
		
		x = _x;
		y = _y;
		
		vx = 5 * _dirx;
		vy = 5 * _diry;
		
		if (_diry > 0 && Main.get().player.vy > 0) {
			vy += Main.get().player.vy;
		}
	}
	
	public override function update()
	{
		for (i in 0 ... 5) {
			x += 0.2 * vx;
			y += 0.2 * vy;
			
			for (c in World.colliders)
			{
				var left:Float = x - 1;
				var right:Float = x + 1;
				var top:Float = y - 1;
				var bottom:Float = y + 1;
				
				if (c.right > left && c.left < right && c.top < bottom && c.bottom > top)
				{
					// Collided.
					Sound.play("blast");
					Main.get().internal_entities.remove(this);
					Particle.explosion(x, y);
					return;
				}
			}
			
			for (e in Main.get().internal_entities)
			{
				if (Std.is(e, Bug))
				{
					var distx:Float = e.x - x;
					var disty:Float = e.y - y;
					var dist:Float = Math.sqrt(distx * distx + disty * disty);
					
					if (dist < 8) {
						// Collided.
						Sound.play("blast");
						cast(e, Bug).killed = true;
						Main.get().internal_entities.remove(this);
						Particle.explosion(x, y);
						return;
					}
				}
			}
		}
	}
	
	public override function render(_camx:Float, _camy:Float)
	{
		if (vx < 0) {
			Gfx.scale( -1, 1, Gfx.CENTER, Gfx.CENTER);
		} else if (vy < 0) {
			Gfx.rotation(270, Gfx.CENTER, Gfx.CENTER);
		} else if (vy > 0) {
			Gfx.rotation(90, Gfx.CENTER, Gfx.CENTER);
		}

		Gfx.drawimage(Math.round(x - _camx - 4), Math.round(y - _camy - 4), "player/bullet");
		
		Gfx.reset();
	}
}