package;
import flash.geom.Rectangle;

class Camera 
{
	var idealcentrex:Float;
	var idealcentrey:Float;
	
	var aimoffsety:Float;
	
	var camcentrex:Float;
	var camcentrey:Float;

	public var outputx:Int;
	public var outputy:Int;
	
	public function new() 
	{
		outputx = 0;
		outputy = 0;
		
		idealcentrex = 0;
		idealcentrey = 0;
		
		aimoffsety = 0;
		
		camcentrex = 0;
		camcentrey = 0;
	}

	function clipxtoregion(x:Float, region:Rectangle) : Float
	{
		if (x < region.left) return region.left;
		else if (x > region.right) return region.right;
		else return x;
	}

	function clipytoregion(y:Float, region:Rectangle) : Float
	{
		if (y < region.top) return region.top;
		else if (y > region.bottom) return region.bottom;
		else return y;
	}
	
	public function update()
	{
		var internalwidth:Int = 222;
		var internalheight:Int = 329;
		var screenwidth:Int = 160;
		var screenheight:Int = 132;
		
		var player:Player = Main.get().player;

		var camregion:Rectangle = new Rectangle(6 + 0.5 * screenwidth, 6 + 0.5 * screenheight, internalwidth - 12 - screenwidth, internalheight - 18 - screenheight);
		
		// Where do we want the camera?
		idealcentrex = player.x;
		idealcentrey = player.y - 4;

		if (player.facingright) {
			idealcentrex += 20;
		} else {
			idealcentrex -= 20;
		}
		
		var idealaimoffsety:Float = 0;
		if (player.aimingup) {
			idealaimoffsety = -16;
		} else if (player.aimingdown) {
			idealaimoffsety = 16;
		}
		
		aimoffsety = 0.9 * aimoffsety + 0.1 * idealaimoffsety;
		idealcentrey += aimoffsety;
		
		idealcentrex = clipxtoregion(idealcentrex, camregion);
		idealcentrey = clipytoregion(idealcentrey, camregion);
		
		// Move the camera itself.
		camcentrex = 0.9 * camcentrex + 0.1 * idealcentrex;
		//camcentrey = 0.7 * camcentrey + 0.3 * idealcentrey;
		camcentrey = idealcentrey;
		
		camcentrex = clipxtoregion(camcentrex, camregion);
		camcentrey = clipytoregion(camcentrey, camregion);
		
		// Convert to integer for rendering.
		outputx = Math.round(camcentrex - 0.5*screenwidth);
		outputy = Math.round(camcentrey - 0.5*screenheight);

		/*
		if (camx < 6) camx = 6;
		if (camx > (internalwidth - 6) - screenwidth) camx = (internalwidth - 6) - screenwidth;
		if (camy < 6) camy = 6;
		if (camy > (internalheight - 12) - screenheight) camy = (internalheight - 12) - screenheight;
		*/
	}
}