package;

import haxegon.*;

class Infestation extends Entity
{
	public var component:Int;
	
	public var style:Int;
	public var animframe:Int;
	
	public function new(_x:Float, _y:Float, _component:Int)
	{
		super();
		
		x = _x;
		y = _y;
		component = _component;
		
		style = Random.int(0, 3);
		animframe = 0;
	}

	public override function update()
	{
		++animframe;
		if (animframe >= 40) {
			animframe = 0;
		}
	}
	
	public function destroy()
	{
		Particle.explosion(x, y);
		
		if (component >= Hardware.DPAD_UP && component <= Hardware.X)
		{
			Particle.externalpurplesmoke(x, y);
		}
	}
	
	public override function render(_camx:Float, _camy:Float)
	{
		var tile:Int = 8 * style + Math.floor(animframe/10);
	
		Gfx.drawtile(Math.round(x - 8 - _camx), Math.round(y - 8 - _camy), "bugs/infestsheet", tile);
	}
	
	public function renderexternal(_camx:Float, _camy:Float)
	{
		if (component >= Hardware.DPAD_UP && component <= Hardware.X || component == Hardware.SCREEN)
		{
			var tile:Int = 8 * style + Math.floor(animframe/10) + 4;
		
			Gfx.drawtile(Math.round(x - 8 - _camx), Math.round(y - 8 - _camy), "bugs/infestsheet", tile);
		}
	}
}